//pr1
var  varianta_o =  [[1,0,1,1,1,0,0,1,0],
                    [0,1,0,1,0,1,0,1,1],
                    [1,1,0,0,1,1,0,0,1],
                    [0,1,0,1,1,0,1,0,1],
                    [0,0,1,1,1,0,1,0,1],
                    [1,0,1,1,0,1,0,1,0],
                    [0,1,1,1,0,0,1,0,1],
                    [1,0,1,0,1,0,1,1,0],
                    [0,1,1,0,1,0,1,0,1],
                    [1,0,1,0,1,0,1,0,1]];
//pr2 a pr3                    
var  varianta_p =  [[0,1,1,1,1,0],
                    [1,0,1,1,1,0],
                    [1,1,0,1,1,0],
                    [1,0,1,0,1,1],
                    [1,1,0,1,0,1]];
                    
var splneno = [0,0,0];
var prohozeno = [0,0,0];
class tabulka{  
  //konstruktor, dulezite informace pro vytvoreni a funkgovani celeho prikladu                                                         
  constructor(rodic,obal_b,obal_zadani,typ_pr){
    this.table = document.createElement('table');
    this.banner = new banner(obal_b);
    this.promaz_obsah = varianta_o[Math.floor(Math.random() * 10)];      
    this.promaz_popisky = varianta_p[Math.floor(Math.random() * 5)];
    this.typ_pr = typ_pr;
    this.pokusu = 0;
    let obal = document.getElementById(rodic);           //
    obal.id = "div_"+obal.id;                            //kvuli ukladani
    if(document.getElementById(obal.id)){
      document.getElementById(obal.id).innerHTML = "";
      obal = document.getElementById(obal.id);
    }

    //obal.removeAttribute("id");
    this.table.id=rodic; 
    this.table.setAttribute("class","cap2");    
    
    this.nastroje = [{nazev:"Housle",soubor:"&#127931;"},
                  {nazev:"Trubka",soubor:"&#127930;"},
                  {nazev:"Saxofon",soubor:"&#127927;"}];
    this.velikosti = ["Malý","Střední","Velký"];
    this.plody = [{nazev:"Jablko",soubor:"jablko"},
                  {nazev:"Rajče",soubor:"rajce"},
                  {nazev:"Víno",soubor:"vino"}];
    this.barvy = ["Malá","Střední","Velká"];
    this.velikost = [75,100,125];
    this.posun = [[0,1,2],[2,0,1],[1,2,0]];
    
    this.vytvor();
    this.printInfo(obal_zadani);
    
    obal.appendChild(this.table);
    
  }  
  //vytvari tabulku a banner, kde jsou elementy pro pretahovani
  vytvor(){
    let index_ar = [0,0];
    //hlava
    let head = this.table.createTHead();
    let radek = head.insertRow(0);
    let bunka = radek.insertCell(0);
    bunka.setAttribute("class","nevidit");
    for(let i = 1; i<=3;i++){
      let popisek = document.createElement('span');
      popisek.innerHTML = this.nastroje[this.posun[this.typ_pr-1][i-1]].nazev;
      bunka = radek.insertCell(i);  
      if((this.typ_pr == 2 || this.typ_pr == 3) && (this.promaz_popisky[index_ar[0]] == 1 && index_ar[0] < 3)){  
        popisek.setAttribute("class","drag tpl"+this.typ_pr); 
        popisek.id = this.typ_pr+""+"0"+i;   
        this.banner.append(popisek);
        bunka.setAttribute("class","drop"+this.typ_pr);
        bunka.classList.add(this.typ_pr+""+"0"+i);
        prohozeno[this.typ_pr-1]++;
      }else{ 
        bunka.appendChild(popisek);
      }
      index_ar[0]++;
    }
    //telo
    let telo = this.table.createTBody();
    for(let i = 0; i < 3; i++){
      radek = telo.insertRow(i); 
      for(let x=0;x<4;x++){     
      bunka = radek.insertCell(x);
        if(x==0){
          let popisek = document.createElement('span');
          popisek.innerHTML = this.barvy[i];
          if((this.typ_pr == 2 || this.typ_pr == 3) && this.promaz_popisky[index_ar[0]] == 1){
            popisek.setAttribute("class","drag tpl"+this.typ_pr);
            popisek.id = this.typ_pr+""+(i+1)+"0";  
            this.banner.append(popisek);
            bunka.setAttribute("class","drop"+this.typ_pr);
            bunka.classList.add(this.typ_pr+""+(i+1)+"0");
            prohozeno[this.typ_pr-1]++;
          }else{ 
            bunka.appendChild(popisek);
          } 
          index_ar[0]++;              
        }else{ 
          let obrazek = document.createElement('span');
          let obr_id = this.typ_pr+""+(i+1)+""+x;
          obrazek.innerHTML = this.nastroje[this.posun[this.typ_pr-1][x-1]].soubor;
          if(this.promaz_obsah[index_ar[1]] == 1 && (this.typ_pr == 1 || this.typ_pr == 3)){       
            obrazek.id = obr_id;
            obrazek.setAttribute("class","drag velikost"+i+" tpl"+this.typ_pr);   
            this.banner.append(obrazek);
            bunka.setAttribute("class","drop"+this.typ_pr);
            bunka.classList.add(obr_id);
            prohozeno[this.typ_pr-1]++;
          }else
            bunka.appendChild(obrazek);
          index_ar[1]++;
        }
      }                                                      
    }
    //vyhonoceni    
    radek = telo.insertRow(3);
    radek.setAttribute("class","no_bg");
    bunka = radek.insertCell(0); 
    bunka.setAttribute("colspan","2");
    let span = document.createElement('span');  
    span.innerHTML = "Chybné pokusy: ";
    let pocet = document.createElement('span'); 
    pocet.id= "pokusy_"+this.typ_pr
    pocet.innerHTML = "0";
    span.appendChild(pocet);
    bunka.appendChild(span);
    bunka = radek.insertCell(1);  
    bunka.setAttribute("colspan","2");
    span = document.createElement('span');
    span.innerHTML = "Správně umístěno: ";
    pocet = document.createElement('span'); 
    pocet.id= "spravne_"+this.typ_pr
    pocet.innerHTML = "0";
    span.appendChild(pocet);
    bunka.appendChild(span);          
  } 
  //vypisuje zadani od textu
  printInfo(kam){
  switch(kam){
    case "z_pr1": 
      document.getElementById(kam).innerHTML = "některé nástroje";
      break;
    case "z_pr2": 
      document.getElementById(kam).innerHTML = "některé popisky řádků a sloupců";
      break;
    case "z_pr3": 
      document.getElementById(kam).innerHTML = "některé údaje";
      break;  
  }
  
  }
}
//rodic pro elementy k pretahovani
class banner{
  constructor(kde){
    this.obal = document.getElementById(kde); 
    this.obal.innerHTML = "";
  }
  
  append(obrazek){
    this.obal.appendChild(obrazek);
  }
}
//D&D
function setDrag(priklad){
jQuery(".drag").draggable({ revert: "invalid" });
jQuery(".drop"+priklad.typ_pr).droppable({
  drop: function(event,ui) {
    event.preventDefault();
    if(event.target.classList.contains("ui-droppable"))
      if(ui.draggable[0].id == event.target.classList[1]){
        event.target.appendChild(ui.draggable[0]);
        jQuery(ui.draggable[0]).draggable("destroy");
        ui.draggable[0].removeAttribute("class");
        ui.draggable[0].removeAttribute("style");
        event.target.removeAttribute("class");
        jQuery(event.target).droppable("destroy");
        splneno[priklad.typ_pr-1]++; 
        document.getElementById("spravne_"+priklad.typ_pr).innerHTML=splneno[priklad.typ_pr-1];
        if(prohozeno[priklad.typ_pr-1] == splneno[priklad.typ_pr-1])
          print_modal("modal","ok");
      }else{
        priklad.pokusu++;
        document.getElementById("pokusy_"+priklad.typ_pr).innerHTML=priklad.pokusu;
        jQuery(ui.draggable[0]).draggable({
          revert: true
        });
      }
    }
  });

}

function prohazej(co,kde){
  var prvky = document.getElementsByClassName(co);   
  var delka = prvky.length;
  var rodic = document.getElementById(kde);
  for(var i = 0; i < delka; i++){    
    var rand = random_int(0,delka-1);
    rodic.appendChild(prvky[rand]);
  }
}

var table_pr1 = new tabulka('t_pr1','b_pr1','z_pr1',1);
setDrag(table_pr1);
prohazej("tpl1","b_pr1");
var table_pr2 = new tabulka('t_pr2','b_pr2','z_pr2',2);
setDrag(table_pr2);       
prohazej("tpl2","b_pr2");
var table_pr3 = new tabulka('t_pr3','b_pr3','z_pr3',3);
setDrag(table_pr3);    
prohazej("tpl3","b_pr3");

//skryti pr2 a pr3
var priklady = document.getElementsByClassName('tabs');
for(let x=1;x<priklady.length;x++)
  priklady[x].classList.add('w3-hide');





